#ifndef EFL_CANVAS_GESTURE_TOUCH_IMPL_HH
#define EFL_CANVAS_GESTURE_TOUCH_IMPL_HH

#include "efl_canvas_gesture_touch.eo.hh"

namespace efl { namespace canvas { 
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Eina_Vector2>::type Gesture_Touch::start_point_get() const
{
    Eina_Vector2 __return_value =  ::efl_gesture_touch_start_point_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Eina_Vector2>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<bool>::type Gesture_Touch::multi_touch_get() const
{
    Eina_Bool __return_value =  ::efl_gesture_touch_multi_touch_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Efl_Canvas_Gesture_Touch_State>::type Gesture_Touch::state_get() const
{
    Efl_Canvas_Gesture_Touch_State __return_value =  ::efl_gesture_touch_state_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Canvas_Gesture_Touch_State>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Gesture_Touch::point_record( ::efl::eolian::in_traits<int>::type tool,  ::efl::eolian::in_traits<Eina_Vector2>::type pos,  ::efl::eolian::in_traits<double>::type timestamp,  ::efl::eolian::in_traits<Efl_Pointer_Action>::type action) const
{
     ::efl_gesture_touch_point_record(_eo_ptr(),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(tool),
         ::efl::eolian::convert_to_c<Eina_Vector2,  ::efl::eolian::in_traits<Eina_Vector2>::type>(pos),
         ::efl::eolian::convert_to_c<double,  ::efl::eolian::in_traits<double>::type>(timestamp),
         ::efl::eolian::convert_to_c<Efl_Pointer_Action,  ::efl::eolian::in_traits<Efl_Pointer_Action>::type>(action));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Eina_Vector2>::type Gesture_Touch::delta( ::efl::eolian::in_traits<int>::type tool) const
{
    Eina_Vector2 __return_value =  ::efl_gesture_touch_delta(_eo_ptr(),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(tool));
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Eina_Vector2>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Eina_Vector2>::type Gesture_Touch::distance( ::efl::eolian::in_traits<int>::type tool) const
{
    Eina_Vector2 __return_value =  ::efl_gesture_touch_distance(_eo_ptr(),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(tool));
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Eina_Vector2>::type>(__return_value);
}
#endif
} } 
namespace eo_cxx {
namespace efl { namespace canvas { 
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Eina_Vector2>::type Gesture_Touch::start_point_get() const
{
    Eina_Vector2 __return_value =  ::efl_gesture_touch_start_point_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Eina_Vector2>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<bool>::type Gesture_Touch::multi_touch_get() const
{
    Eina_Bool __return_value =  ::efl_gesture_touch_multi_touch_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Efl_Canvas_Gesture_Touch_State>::type Gesture_Touch::state_get() const
{
    Efl_Canvas_Gesture_Touch_State __return_value =  ::efl_gesture_touch_state_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Canvas_Gesture_Touch_State>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Gesture_Touch::point_record( ::efl::eolian::in_traits<int>::type tool,  ::efl::eolian::in_traits<Eina_Vector2>::type pos,  ::efl::eolian::in_traits<double>::type timestamp,  ::efl::eolian::in_traits<Efl_Pointer_Action>::type action) const
{
     ::efl_gesture_touch_point_record(_eo_ptr(),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(tool),
         ::efl::eolian::convert_to_c<Eina_Vector2,  ::efl::eolian::in_traits<Eina_Vector2>::type>(pos),
         ::efl::eolian::convert_to_c<double,  ::efl::eolian::in_traits<double>::type>(timestamp),
         ::efl::eolian::convert_to_c<Efl_Pointer_Action,  ::efl::eolian::in_traits<Efl_Pointer_Action>::type>(action));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Eina_Vector2>::type Gesture_Touch::delta( ::efl::eolian::in_traits<int>::type tool) const
{
    Eina_Vector2 __return_value =  ::efl_gesture_touch_delta(_eo_ptr(),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(tool));
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Eina_Vector2>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Eina_Vector2>::type Gesture_Touch::distance( ::efl::eolian::in_traits<int>::type tool) const
{
    Eina_Vector2 __return_value =  ::efl_gesture_touch_distance(_eo_ptr(),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(tool));
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Eina_Vector2>::type>(__return_value);
}
#endif
inline efl::canvas::Gesture_Touch::operator ::efl::canvas::Gesture_Touch() const { return *static_cast< ::efl::canvas::Gesture_Touch const*>(static_cast<void const*>(this)); }
inline efl::canvas::Gesture_Touch::operator ::efl::canvas::Gesture_Touch&() { return *static_cast< ::efl::canvas::Gesture_Touch*>(static_cast<void*>(this)); }
inline efl::canvas::Gesture_Touch::operator ::efl::canvas::Gesture_Touch const&() const { return *static_cast< ::efl::canvas::Gesture_Touch const*>(static_cast<void const*>(this)); }
} } }
#endif
